/*SIEDmaker4win v0.95
23 march 2015

Copyright (C) 2015
Anthony Delaune
Laboratoire GPM UMR CNRS 6634 Equipe NanoCARE
Universit de Rouen
anthony.delaune@univ-rouen.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <commctrl.h>

#define IDM_QUIT 1
#define IDM_OPEN 20
#define IDM_SAVE 21
#define IDM_ABOUT 3
#define IDM_static 4
#define ID_RADIO_ONETAIL 51
#define ID_RADIO_TWOTAIL 52
#define ID_PUSH_SUM 60
#define ID_RADIO_SUM_HHC 63
#define ID_RADIO_SUM_MC 64
#define ID_RADIO_SUM_PROJ 65
#define ID_EDIT_SHIFT 61
#define ID_COMBO_SUM 62
#define ID_COMBO_PLANE 70
#define ID_COMBO_NUM 71
#define ID_COMBO_DENOM 72
#define ID_COMBO_NORM 73
#define ID_EDIT_PREFIX 55
#define ID_COMBO_PARAM 81
#define ID_CHECKBOX_ALT 80
#define ID_EDIT_STDDIR 82
#define ID_EDIT_ALTDIR 83
#define ID_EDIT_ALTVAL 84
#define ID_RADIO_RANK0 90
#define ID_RADIO_RANK1 91
#define ID_RADIO_RANK2 92
#define ID_RADIO_RANK3 93
#define ID_RADIO_RANK4 94
#define ID_CHECKBOX_REF 100
#define ID_EDIT_REF 101
#define ID_TRACKBAR_REF 102
#define ID_TRACKBAR_TRESH 103
#define ID_CHECKBOX_PROBA 110
#define ID_EDIT_PROBA 111
#define ID_EDIT_SCRIPT 120
HWND hwnd;
HWND RADIO_ONETAIL;
HWND RADIO_TWOTAIL;
HWND PUSH_SUM;
HWND EDIT_SHIFT;
HWND COMBO_SUM;
HWND RADIO_SUM_HHC;
HWND RADIO_SUM_MC;
HWND RADIO_SUM_PROJ;
HWND COMBO_PLANE;
HWND COMBO_NUM;
HWND COMBO_DENOM;
HWND COMBO_NORM;
HWND EDIT_PREFIX;
HWND COMBO_PARAM;
HWND CHECKBOX_ALT;
HWND EDIT_STDDIR;
HWND EDIT_ALTDIR;
HWND EDIT_ALTVAL;
HWND RADIO_RANK0;
HWND RADIO_RANK1;
HWND RADIO_RANK2;
HWND RADIO_RANK3;
HWND RADIO_RANK4;
HWND CHECKBOX_REF;
HWND EDIT_REF;
HWND TRACKBAR_REF;
HWND TRACKBAR_TRESH;
HWND CHECKBOX_PROBA;
HWND EDIT_PROBA;
HWND STATIC_REF;
HWND STATIC_TRESH;
HWND EDIT_SCRIPT;
HWND image_box;

static HWND hwndStatic;
HINSTANCE hinst;
char nom_mass[5][8]={};
unsigned int *image_sum;
unsigned int *image;
int *im_denom;
int raster_line, raster_col;
int nbmass=0;
int nbplan=0;
int plan_actif;
unsigned int seuil_denom, seuil_moy;
int filtretype=3, two_tailed=0;
char *nom_fich_origin=NULL;
int is_sum_calculated;
int maxpix;
int sum_meth=1;
TCHAR buff[100];
HDC hdc;

CHAR szFile[MAX_PATH]={0};

LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
char pathfich[300]="";

int opensims(CHAR szFile[300])
{
 char *nom_temp;
 int longueur, u, v;
 char nomfich[32]="";
 char temp[32];
 FILE *fp;
 int header_size,  a, b, i=0, j=1, k=0, l=0;
 int offset=0;
 long int image_byte=0;
 SendMessage(COMBO_PLANE, CB_RESETCONTENT, 0, 0);
 SendMessage(COMBO_SUM, CB_RESETCONTENT, 0, 0);
 SendMessage(COMBO_NUM, CB_RESETCONTENT, 0, 0);
 SendMessage(COMBO_DENOM, CB_RESETCONTENT, 0, 0);
 SendMessage(COMBO_NORM, CB_RESETCONTENT, 0, 0);
 fp=fopen(szFile, "rb");
 fflush(fp);
 fseek(fp, 411, SEEK_SET);
 fread(&nbmass, 1, 1, fp);


 for (i=0; i<nbmass; i++)
 {
      fseek(fp, 517+i*192, SEEK_SET);
      fread(&nom_mass[i], 7, 1, fp);
      for (j=0; j<7; j++) {
            if (nom_mass[i][j]==32)
        {
         nom_mass[i][j]=95;
         }
      }
      SendMessage(COMBO_SUM, CB_ADDSTRING, 0, nom_mass[i]);
 }
 fseek(fp, 10, SEEK_SET);
 fread(&a, 1, 1, fp);
 fread(&b, 1, 1, fp);
 header_size=a*256+b;
 fseek(fp, header_size-69, SEEK_SET);
 fread(&nbplan, 1, 1, fp);
 for (j=0; j<nbplan; j++)
 {
    sprintf(temp, "plane %d", (j+1));
    SendMessage(COMBO_PLANE, CB_ADDSTRING, 0, temp);
 }
    sprintf(temp, "plane_sum");
    SendMessage(COMBO_PLANE, CB_ADDSTRING, 0, temp);

    fseek(fp, header_size-78, SEEK_SET);
    fread(&a, 1, 1, fp);
    fread(&b, 1, 1, fp);
    raster_col=256*a+ b;

    fseek(fp, header_size-76, SEEK_SET);
    fread(&a, 1, 1, fp);
    fread(&b, 1, 1, fp);
    raster_line=256*a + b;


 image=(unsigned int*) calloc((nbplan+1)*nbmass*raster_col*raster_line, sizeof(unsigned int));

 for (i=0; i<nbplan; i++)
 {
 for (j=0; j<nbmass; j++)
    {
    sprintf(buff, "Opening mass %d / %d plane %d / %d ... Please wait", j+1, nbmass, i+1, nbplan);
    SetWindowText(hwndStatic, buff);

      for (k=0; k<raster_line; k++)
        {
               for (l=0; l<raster_col; l++)
            {
              fseek(fp, header_size+offset, SEEK_SET);
              fread(&a, 1, 1, fp);
              fread(&b, 1, 1, fp);
              image_byte=a*256+b;
              image[i*nbmass*raster_line*raster_col +j*raster_line*raster_col+ k*raster_col+l]=image_byte;
              offset=offset+2;
            }
         }
    }
 }
 fclose(fp);
 longueur=strlen(szFile);
 for (u=(longueur-3); ((szFile[u])!='\\') ; u--)
 {
    //
 }
 u++;
 nom_fich_origin = (char*) calloc((longueur-3-u), sizeof(char));
 nom_temp=(char*) calloc(4, sizeof(char));
 for (v=0; v<4; v++)
    {
        nom_temp[v]=szFile[v+u];
    }
 if (!strcmp (nom_temp, "SUN_"))
 {
    u=u+4;
 }
 for (v=0; v<(longueur-3-u); v++)
 {
    nom_fich_origin[v]=szFile[v+u];
 }
 nom_fich_origin[v]='\0';
 SendMessage(EDIT_PREFIX, WM_SETTEXT, NULL, nom_fich_origin);
 free(nom_fich_origin);
 free(nom_temp);
 sprintf(buff, "Ready...");
 SetWindowText(hwndStatic, buff);
 im_denom=(int*)calloc(3*raster_line*raster_col, sizeof(int));
 return 1;
}

VOID fill_the_window(HWND win)
{
HFONT hFont=CreateFont (15, 0, 0, 0, FW_SEMIBOLD, FALSE, FALSE, FALSE,
			ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
			DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, L"Arial");
    hwndStatic = CreateWindow(TEXT("static") , NULL, WS_CHILD | WS_VISIBLE,
               150, 367, 440, 16, win,(HMENU) IDM_static, hinst, NULL);
    SendMessage (hwndStatic, WM_SETFONT, (WPARAM) hFont, TRUE);
    sprintf(buff, "Ready...");
                    SetWindowText(hwndStatic, buff);
    HWND hGroup;
    hGroup=CreateWindow(
                        "BUTTON",
                        "Analysis mode",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        5,5,
                        580,40,
                        win,
                        NULL,
                        hinst,
                        NULL);
            {
            HWND hControle;
            RADIO_ONETAIL=CreateWindow(
                                    "BUTTON",
                                    "One-tailed test (enrichment detection)",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON|WS_GROUP,
                                    10+10,10+10,
                                    300,20,
                                    win,
                                    (HMENU)ID_RADIO_ONETAIL,
                                    hinst,
                                    NULL);
            SendMessage(RADIO_ONETAIL, BM_SETCHECK, BST_CHECKED, 0);
            RADIO_TWOTAIL=CreateWindow(
                                    "BUTTON",
                                    "Two-tailed test (heterogeneity study)",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
                                    300+10,10+10,
                                    270,20,
                                    win,
                                    (HMENU)ID_RADIO_TWOTAIL,
                                    hinst,
                                    NULL);
            }
    SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
    SendMessage (RADIO_ONETAIL, WM_SETFONT, (WPARAM) hFont, TRUE);
    SendMessage (RADIO_TWOTAIL, WM_SETFONT, (WPARAM) hFont, TRUE);

        hGroup=CreateWindow(
                        "BUTTON",
                        "Plane sumation",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        5,45,
                        580,75,
                        win,
                        NULL,
                        hinst,
                        NULL);
            {
            HWND hControle;
            PUSH_SUM=CreateWindow(
                                    "BUTTON",
                                    "Sum the planes (autotrack)",
                                    WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
                                    10,60,
                                    180,30,
                                    win,
                                    (HMENU)ID_PUSH_SUM,
                                    hinst,
                                    NULL);
                hControle= CreateWindow(TEXT("static") , "Max shift:", WS_CHILD | WS_VISIBLE,
               215, 67, 80, 16, win,(HMENU) IDM_static, hinst, NULL);
                SendMessage (hControle, WM_SETFONT, (WPARAM) hFont, TRUE);
{
            HWND hControle;
            RADIO_SUM_HHC=CreateWindow(
                                    "BUTTON",
                                    "Joint Entropy meth.",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON|WS_GROUP,
                                    10+40,85+10,
                                    160,20,
                                    win,
                                    (HMENU)ID_RADIO_SUM_HHC,
                                    hinst,
                                    NULL);
            SendMessage(RADIO_SUM_HHC, BM_SETCHECK, BST_CHECKED, 0);
            RADIO_SUM_MC=CreateWindow(
                                    "BUTTON",
                                    "Least squ. meth.",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
                                    180+40,85+10,
                                    160,20,
                                    win,
                                    (HMENU)ID_RADIO_SUM_MC,
                                    hinst,
                                    NULL);
            RADIO_SUM_PROJ=CreateWindow(
                                    "BUTTON",
                                    "Projection meth.",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
                                    340+40,85+10,
                                    160,20,
                                    win,
                                    (HMENU)ID_RADIO_SUM_PROJ,
                                    hinst,
                                    NULL);
            }
    SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
    SendMessage (RADIO_SUM_HHC, WM_SETFONT, (WPARAM) hFont, TRUE);
    SendMessage (RADIO_SUM_MC, WM_SETFONT, (WPARAM) hFont, TRUE);
    SendMessage (RADIO_SUM_PROJ, WM_SETFONT, (WPARAM) hFont, TRUE);
               EDIT_SHIFT=CreateWindow(
                                    "EDIT",
                                    "0",
                                    WS_CHILD|WS_VISIBLE|ES_NUMBER,
                                    280,67,
                                    20,16,
                                    win,
                                    (HMENU)ID_EDIT_SHIFT,
                                    hinst,
                                    NULL);
                SendMessage (EDIT_SHIFT, WM_SETFONT, (WPARAM) hFont, TRUE);
   hControle= CreateWindow(TEXT("static") , "Reference mass:", WS_CHILD | WS_VISIBLE,
               330, 67, 120, 16, win,(HMENU) IDM_static, hinst, NULL);
               SendMessage (hControle, WM_SETFONT, (WPARAM) hFont, TRUE);

               COMBO_SUM=CreateWindow(
                                    "COMBOBOX",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST,
                                    450,62,
                                    100,120,
                                    win,
                                    (HMENU)ID_COMBO_SUM,
                                    hinst,
                                    NULL);
            SendMessage (COMBO_SUM, WM_SETFONT, (WPARAM) hFont, TRUE);

            }
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
        SendMessage (PUSH_SUM, WM_SETFONT, (WPARAM) hFont, TRUE);

    hGroup=CreateWindow(
                        "BUTTON",
                        "Active plane",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        5,125,
                        140,42,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);

            {
            COMBO_PLANE=CreateWindow(
                                    "COMBOBOX",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST,
                                    10,140,
                                    130,120,
                                    win,
                                    (HMENU)ID_COMBO_PLANE,
                                    hinst,
                                    NULL);
            SendMessage (COMBO_PLANE, WM_SETFONT, (WPARAM) hFont, TRUE);
            }
        hGroup=CreateWindow(
                        "BUTTON",
                        "Label mass",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        152,125,
                        140,42,
                        win,
                        NULL,
                        hinst,
                        NULL);
        SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);

            {

            COMBO_NUM=CreateWindow(
                                    "COMBOBOX",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST|CBS_DISABLENOSCROLL,
                                    157,140,
                                    130,120,
                                    win,
                                    (HMENU)ID_COMBO_NUM,
                                    hinst,
                                    NULL);
            SendMessage (COMBO_NUM, WM_SETFONT, (WPARAM) hFont, TRUE);
   }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Non-label mass",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        298,125,
                        140,42,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
   {
            COMBO_DENOM=CreateWindow(
                                    "COMBOBOX",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST,
                                    303,140,
                                    130,120,
                                    win,
                                    (HMENU)ID_COMBO_DENOM,
                                    hinst,
                                    NULL);
            SendMessage (COMBO_DENOM, WM_SETFONT, (WPARAM) hFont, TRUE);
  }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Add. mass",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        445,125,
                        140,42,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {
            COMBO_NORM=CreateWindow(
                                    "COMBOBOX",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST,
                                    450,140,
                                    130,120,
                                    win,
                                    (HMENU)ID_COMBO_NORM,
                                    hinst,
                                    NULL);
            SendMessage (COMBO_NORM, WM_SETFONT, (WPARAM) hFont, TRUE);
  }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Analysis prefix",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        5,170,
                        140,36,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {

            EDIT_PREFIX=CreateWindow(
                                    "EDIT",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE,
                                    10,185,
                                    130,16,
                                    win,
                                    (HMENU)ID_EDIT_PREFIX,
                                    hinst,
                                    NULL);
            SendMessage (EDIT_PREFIX, WM_SETFONT, (WPARAM) hFont, TRUE);
  }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Alternate analysis",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        150,170,
                        290,125,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {
                HWND hControle;
                CHECKBOX_ALT=CreateWindow(
                                    "BUTTON",
                                    "Activate alt.",
                                    WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX,
                                    155,190,
                                    120,20,
                                    win,
                                    (HMENU)ID_CHECKBOX_ALT,
                                    hinst,
                                    NULL);
    SendMessage (CHECKBOX_ALT, WM_SETFONT, (WPARAM) hFont, TRUE);

                hControle= CreateWindow(TEXT("static"),
                                        "Alt. parameter",
                                        WS_CHILD | WS_VISIBLE,
                                        155, 213,
                                        100, 16,
                                        win,
                                        (HMENU) IDM_static,
                                        hinst,
                                        NULL);
               SendMessage (hControle, WM_SETFONT, (WPARAM) hFont, TRUE);
            COMBO_PARAM=CreateWindow(
                                    "COMBOBOX",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST,
                                    250,210,
                                    100,120,
                                    win,
                                    (HMENU)ID_COMBO_PARAM,
                                    hinst,
                                    NULL);
                SendMessage (COMBO_PARAM, WM_SETFONT, (WPARAM) hFont, TRUE);
  EDIT_ALTVAL=CreateWindow(
                                    "EDIT",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE,
                                    355,213,
                                    75,16,
                                    win,
                                    (HMENU)ID_EDIT_ALTVAL,
                                    hinst,
                                    NULL);
		SendMessage (EDIT_ALTVAL, WM_SETFONT, (WPARAM) hFont, TRUE);

                hControle= CreateWindow(TEXT("static"),
                                        "Standard directory",
                                        WS_CHILD | WS_VISIBLE,
                                        155, 240,
                                        130, 16,
                                        win,
                                        (HMENU) IDM_static,
                                        hinst,
                                        NULL);
               SendMessage (hControle, WM_SETFONT, (WPARAM) hFont, TRUE);
  EDIT_STDDIR=CreateWindow(
                                    "EDIT",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE,
                                    300,240,
                                    130,16,
                                    win,
                                    (HMENU)ID_EDIT_STDDIR,
                                    hinst,
                                    NULL);
                SendMessage (EDIT_STDDIR, WM_SETFONT, (WPARAM) hFont, TRUE);
                    hControle= CreateWindow(TEXT("static"),
                                        "Alternative directory",
                                        WS_CHILD | WS_VISIBLE,
                                        155, 265,
                                        130, 16,
                                        win,
                                        (HMENU) IDM_static,
                                        hinst,
                                        NULL);
               SendMessage (hControle, WM_SETFONT, (WPARAM) hFont, TRUE);
  EDIT_ALTDIR=CreateWindow(
                                    "EDIT",
                                    NULL,
                                    WS_CHILD|WS_VISIBLE,
                                    300,265,
                                    130,16,
                                    win,
                                    (HMENU)ID_EDIT_ALTDIR,
                                    hinst,
                                    NULL);
SendMessage (EDIT_ALTDIR, WM_SETFONT, (WPARAM) hFont, TRUE);
            }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Lambda matrix ext.",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        5,210,
                        140,155,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {
                RADIO_RANK0=CreateWindow(
                                    "BUTTON",
                                    "Rank 0 (1 pix.)",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON|WS_GROUP,
                                    10,235,
                                    130,20,
                                    win,
                                    (HMENU)ID_RADIO_RANK0,
                                    hinst,
                                    NULL);
            RADIO_RANK1=CreateWindow(
                                    "BUTTON",
                                    "Rank 1 (9 pix.)",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
                                    10,260,
                                    130,20,
                                    win,
                                    (HMENU)ID_RADIO_RANK1,
                                    hinst,
                                    NULL);
            RADIO_RANK2=CreateWindow(
                                    "BUTTON",
                                    "Rank 2 (25 pix.)",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
                                    10,285,
                                    130,20,
                                    win,
                                    (HMENU)ID_RADIO_RANK2,
                                    hinst,
                                    NULL);
                RADIO_RANK3=CreateWindow(
                                    "BUTTON",
                                    "Rank 3 (49 pix.)",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
                                    10,310,
                                    130,20,
                                    win,
                                    (HMENU)ID_RADIO_RANK3,
                                    hinst,
                                    NULL);
            SendMessage(RADIO_RANK3, BM_SETCHECK, BST_CHECKED, 0);
            RADIO_RANK4=CreateWindow(
                                    "BUTTON",
                                    "Rank 4 (81 pix.)",
                                    WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
                                    10,335,
                                    130,20,
                                    win,
                                    (HMENU)ID_RADIO_RANK4,
                                    hinst,
                                    NULL);
            SendMessage (RADIO_RANK0, WM_SETFONT, (WPARAM) hFont, TRUE);
  SendMessage (RADIO_RANK1, WM_SETFONT, (WPARAM) hFont, TRUE);
  SendMessage (RADIO_RANK2, WM_SETFONT, (WPARAM) hFont, TRUE);
  SendMessage (RADIO_RANK3, WM_SETFONT, (WPARAM) hFont, TRUE);
  SendMessage (RADIO_RANK4, WM_SETFONT, (WPARAM) hFont, TRUE);
  }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Isotopic fraction reference",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        150,295,
                        290,70,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {
                HWND hControle;
                CHECKBOX_REF=CreateWindow(
                                    "BUTTON",
                                    "Set reference value",
                                    WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX,
                                    155,312,
                                    160,20,
                                    win,
                                    (HMENU)ID_CHECKBOX_REF,
                                    hinst,
                                    NULL);
                SendMessage (CHECKBOX_REF, WM_SETFONT, (WPARAM) hFont, TRUE);
  EDIT_REF=CreateWindow(
                                    "EDIT",
                                    "-0.0037",
                                    WS_CHILD|WS_VISIBLE,
                                    320,314,
                                    110,16,
                                    win,
                                    (HMENU)ID_EDIT_REF,
                                    hinst,
                                    NULL);

            SendMessage (EDIT_REF, WM_SETFONT, (WPARAM) hFont, TRUE);
  hControle= CreateWindow(TEXT("static"),
                                        "Ref. threshold",
                                        WS_CHILD | WS_VISIBLE,
                                        155, 335,
                                        100, 16,
                                        win,
                                        (HMENU) IDM_static,
                                        hinst,
                                        NULL);
            SendMessage (hControle, WM_SETFONT, (WPARAM) hFont, TRUE);
  TRACKBAR_REF=CreateWindow(
                                    TRACKBAR_CLASS,
                                    "",
                                    WS_CHILD|WS_VISIBLE,
                                    240,337,
                                    160,16,
                                    win,
                                    (HMENU)ID_TRACKBAR_REF,
                                    hinst,
                                    NULL);
                SendMessage(TRACKBAR_REF, TBM_SETRANGEMIN, TRUE, 0);

            STATIC_REF = CreateWindow(TEXT("static"),
                                        NULL,
                                        WS_CHILD | WS_VISIBLE,
                                        400, 335,
                                        35, 16,
                                        win,
                                        (HMENU) IDM_static,
                                        hinst,
                                        NULL);
            SendMessage (STATIC_REF, WM_SETFONT, (WPARAM) hFont, TRUE);
  }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Analysis threshold",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        445,295,
                        140,70,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {
                TRACKBAR_TRESH=CreateWindow(
                                    TRACKBAR_CLASS,
                                    "",
                                    WS_CHILD|WS_VISIBLE,
                                    450,337,
                                    130,16,
                                    win,
                                    (HMENU)ID_TRACKBAR_TRESH,
                                    hinst,
                                    NULL);
            SendMessage(TRACKBAR_TRESH, TBM_SETRANGEMIN, TRUE, 1);

            STATIC_TRESH = CreateWindow(TEXT("static"),
                                        NULL,
                                        WS_CHILD | WS_VISIBLE,
                                        500, 320,
                                        40, 16,
                                        win,
                                        (HMENU) IDM_static,
                                        hinst,
                                        NULL);

            SendMessage (STATIC_TRESH, WM_SETFONT, (WPARAM) hFont, TRUE);
  }
            hGroup=CreateWindow(
                        "BUTTON",
                        "2nd class alpha risk",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        445,195,
                        140,70,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {
                HWND hControle;
                CHECKBOX_PROBA=CreateWindow(
                                    "BUTTON",
                                    "Change",
                                    WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX,
                                    450,210,
                                    120,20,
                                    win,
                                    (HMENU)ID_CHECKBOX_PROBA,
                                    hinst,
                                    NULL);
            SendMessage (CHECKBOX_PROBA, WM_SETFONT, (WPARAM) hFont, TRUE);
  hControle= CreateWindow(TEXT("static"),
                                        "New Value",
                                        WS_CHILD | WS_VISIBLE,
                                        450, 235,
                                        70, 16,
                                        win,
                                        (HMENU) IDM_static,
                                        hinst,
                                        NULL);
            SendMessage (hControle, WM_SETFONT, (WPARAM) hFont, TRUE);
  EDIT_PROBA=CreateWindow(
                                    "EDIT",
                                    "0.1",
                                    WS_CHILD|WS_VISIBLE,
                                    525,235,
                                    45,16,
                                    win,
                                    (HMENU)ID_EDIT_PROBA,
                                    hinst,
                                    NULL);
            SendMessage (EDIT_PROBA, WM_SETFONT, (WPARAM) hFont, TRUE);
  }
            hGroup=CreateWindow(
                        "BUTTON",
                        "Script",
                        WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                        5,380,
                        585,150,
                        win,
                        NULL,
                        hinst,
                        NULL);
            SendMessage (hGroup, WM_SETFONT, (WPARAM) hFont, TRUE);
  {
                EDIT_SCRIPT=CreateWindow(
                                    "EDIT",
                                    "#!/bin/sh\nDIR=$( cd \"$( dirname \"${BASH_SOURCE[0]}\" )\" && pwd )\n",
                                    WS_CHILD|WS_VISIBLE|ES_AUTOVSCROLL|ES_MULTILINE|ES_WANTRETURN,
                                    10,395,
                                    570,130,
                                    win,
                                    (HMENU)ID_EDIT_SCRIPT,
                                    hinst,
                                    NULL);
SendMessage (EDIT_SCRIPT, WM_SETFONT, (WPARAM) hFont, TRUE);

            image_box=CreateWindow(TEXT("static") ,
                                    NULL,
                                    WS_CHILD | WS_VISIBLE,
                                590, 10, 512, 512,
                                win,
                                (HMENU) IDM_static,
                                   hinst,
                                   NULL);
            }
}

void Addscript(HWND editbox, LPCTSTR texte)
{
    int nLength = GetWindowTextLength(editbox);
    SendMessage(editbox, EM_SETSEL, (WPARAM)nLength, (LPARAM)nLength);
    SendMessage(editbox, EM_REPLACESEL, (WPARAM)FALSE, (LPARAM)texte);
}


static save(void)
{
    int nbconfig=1;   //number of configuration to save
    int i,j, u;
    int id_im_num;          //id determined from the numerator box of choice
    char fich_num[300];     //name of the numerator file to save from nommass[] and sPath
    int id_im_denom;        //id determined from the denominator box of choice
    char fich_denom[300];     //name of the denominator file to save from nommass [] and sPath
    int id_im_norm;        //id determined from the norm box of choice
    char fich_norm[300];     //name of the norm file to save from nommass [] and sPath
    char fich_config[300];
    char path_save[300];
    char nom_temp[300];
    TCHAR buf_temp[300];
    FILE *config;
    int ok;
    FILE *im;
    float moyenne;
    int longueur;
    sprintf(buff, "Saving...");
    SetWindowText(hwndStatic, buff);
    getcwd(path_save, 300);

    id_im_num = SendMessage(COMBO_NUM, CB_GETCURSEL, 0,0);
    id_im_denom = SendMessage(COMBO_DENOM, CB_GETCURSEL, 0,0);
    id_im_norm = SendMessage(COMBO_NORM, CB_GETCURSEL, 0,0);
    if (id_im_norm==CB_ERR)
    {
        id_im_norm=id_im_denom; //im norm is optionnal
    }
    if (id_im_num==CB_ERR || id_im_denom==CB_ERR)
    {
        
        sprintf(buff, "Incomplete selection. Unable to save");
        SetWindowText(hwndStatic, buff);
    }

    else
    {
        ((WORD*)buf_temp)[0]=300;
        longueur=SendMessage(EDIT_PREFIX, EM_GETLINE, 0,(LPARAM)buf_temp);
        buf_temp[longueur]='\0';
        if (plan_actif==nbplan)
        {
        sprintf(nom_temp, "%s_sum_planes", buf_temp);
        }
        else
        {
        sprintf(nom_temp, "%s_p%d", buf_temp, plan_actif+1);
        }
        if ((chdir(nom_temp))==-1)
        {
            mkdir(nom_temp);
            chdir(nom_temp);
        }
        sprintf(fich_num, "%s_%s.txt", nom_temp, nom_mass[id_im_num]);
        sprintf(fich_denom, "%s_%s.txt", nom_temp, nom_mass[id_im_denom]);
        sprintf(fich_norm, "%s_%s.txt", nom_temp, nom_mass[id_im_norm]);

        if ((SendMessage(CHECKBOX_ALT, BM_GETCHECK, 0, 0))==BST_CHECKED)
        {
            nbconfig=2;
        }

        for (u=0; u<nbconfig; u++)
        {
                    Addscript(EDIT_SCRIPT, "cd $DIR\n");
                    Addscript(EDIT_SCRIPT, "cd ");
                    Addscript(EDIT_SCRIPT, nom_temp);
                    Addscript(EDIT_SCRIPT, "\n");
                if (nbconfig==2)
                {
                    if (u==0)
                    {
                        longueur=SendMessage(EDIT_STDDIR, EM_GETLINE, 0, &buf_temp);
                        buf_temp[longueur]='\0';
                        chdir(path_save);
                        chdir(nom_temp);
                        mkdir(buf_temp);
                        chdir(buf_temp);

                        Addscript(EDIT_SCRIPT, "cd ");
                        Addscript(EDIT_SCRIPT, buf_temp);
                        Addscript(EDIT_SCRIPT, "\n");
                    }
                    if (u==1)
                    {
                        longueur=SendMessage(EDIT_ALTDIR, EM_GETLINE, 0, &buf_temp);
                        buf_temp[longueur]='\0';
                        chdir(path_save);
                        chdir(nom_temp);
                        mkdir(buf_temp);
                        chdir(buf_temp);
                        Addscript(EDIT_SCRIPT, "cd ");
                        Addscript(EDIT_SCRIPT, buf_temp);
                        Addscript(EDIT_SCRIPT, "\n");
                    }
                }
            Addscript(EDIT_SCRIPT, "mpiexec -np 8  SIED config.ini\n\n");

            config = fopen("config.ini", "w");
            fflush(config);
            fprintf(config, "%d\n", raster_line);
            fprintf(config, "%d\n", raster_col); // for SIED 1.7, both raster_line and raster_col are required
            if (((u*nbconfig)==2)*((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0))==0))
            {
                longueur=SendMessage(EDIT_ALTVAL, EM_GETLINE, 0, &buf_temp);
                buf_temp[longueur]='\0';
                fprintf(config, "%s\n", buf_temp);
            }
            else
            {
                fprintf(config, "%d\n", filtretype);
            }
            fprintf(config, "%s\n", fich_num);
            fprintf(config, "%s\n", fich_denom);

            if (((u*nbconfig)==2)*((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0))==1))
            {
                longueur=SendMessage(EDIT_ALTVAL, EM_GETLINE, 0, &buf_temp);
                buf_temp[longueur]='\0';
                fprintf(config, "%s\n", buf_temp);
            }
            else
            {
                fprintf(config, "%d\n", SendMessage(TRACKBAR_TRESH, TBM_GETPOS, 0,0));
            }

            if (((u*nbconfig)==2)*((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0))==2))
            {
                longueur=SendMessage(EDIT_ALTVAL, EM_GETLINE, 0, &buf_temp);
                buf_temp[longueur]='\0';
                fprintf(config, "%s\n", buf_temp);
            }
            else
            {
                fprintf(config, "%d\n", SendMessage(TRACKBAR_REF, TBM_GETPOS, 0,0));
            }

            fprintf(config, "%s\n", fich_norm);

            if (((u*nbconfig)==2)*((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0))==3))
            {
                longueur=SendMessage(EDIT_ALTVAL, EM_GETLINE, 0, &buf_temp);
                buf_temp[longueur]='\0';
                fprintf(config, "%s\n", buf_temp);
            }
            else
            {
                longueur=SendMessage(EDIT_REF, EM_GETLINE, 0, &buf_temp);
                buf_temp[longueur]='\0';
                fprintf(config, "%s\n", buf_temp);
            }

            if (((u*nbconfig)==2)*((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0))==4))
            {
                longueur=SendMessage(EDIT_ALTVAL, EM_GETLINE, 0, &buf_temp);
                buf_temp[longueur]='\0';
                fprintf(config, "%s\n", buf_temp);
            }
            else
            {
                if ((SendMessage(CHECKBOX_PROBA, BM_GETCHECK,0,0))==BST_CHECKED)
                {
                 longueur=SendMessage(EDIT_PROBA, EM_GETLINE, 0, &buf_temp);
                buf_temp[longueur]='\0';
                fprintf(config, "%s\n", buf_temp);
                }
                else{
                   fprintf(config, "0.1\n");
                }
            }
            fprintf(config, "%d\n", two_tailed);
            fprintf(config, "%s\n", nom_temp);
            fclose(config);
            im = fopen(fich_num, "w");
            fflush(im);
            for (i=0; i<raster_line; i++)
            {
                for (j=0; j<raster_col; j++)
                {
                    fprintf(im, "%d\t", image[plan_actif*raster_line*raster_col*nbmass+id_im_num*raster_line*raster_col+i*raster_col+j]);
                }
                fprintf(im, "\n");
            }
            fclose(im);

            im = fopen(fich_denom, "w");
            fflush(im);
            for (i=0; i<raster_line; i++)
            {
                for (j=0; j<raster_col; j++)
                {
                    fprintf(im, "%d\t", image[plan_actif*raster_line*raster_col*nbmass+id_im_denom*raster_line*raster_col+i*raster_col+j]);
                }
                fprintf(im, "\n");
            }
            fclose(im);

            im = fopen(fich_norm, "w");
            fflush(im);
            for (i=0; i<raster_line; i++)
            {
                for (j=0; j<raster_col; j++)
                {
                    fprintf(im, "%d\t", image[plan_actif*raster_line*raster_col*nbmass+id_im_norm*raster_line*raster_col+i*raster_col+j]);
                }
                fprintf(im, "\n");
            }
            fclose(im);
        }
        sprintf(buff, "Images are saved.");
        SetWindowText(hwndStatic, buff);
        chdir(path_save);
    }
    return;
}


static on_choice_param(void)
{
    char temp_buf[32];
    if ((SendMessage(CHECKBOX_ALT, BM_GETCHECK, 0,0))==BST_CHECKED)
    {
        if ((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0)==0))
        {
            //matrix rank
            sprintf(temp_buf, "matrix_rk_%d", filtretype);
            SendMessage(EDIT_STDDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "alt_matrix_rk");
            SendMessage(EDIT_ALTDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "%d", filtretype);
            SendMessage(EDIT_ALTVAL, WM_SETTEXT, NULL, (LPARAM)temp_buf);
        }
        if ((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0)==1))
        {
            //Back tresh
            sprintf(temp_buf, "STD_anal_tresh");
            SendMessage(EDIT_STDDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "ALT_anal_tresh");
            SendMessage(EDIT_ALTDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "%d", seuil_denom);
            SendMessage(EDIT_ALTVAL, WM_SETTEXT, NULL, (LPARAM)temp_buf);
        }
        if ((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0)==2))
        {
            //Ref tresh
            sprintf(temp_buf, "STD_ref_tresh");
            SendMessage(EDIT_STDDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "ALT_ref_tresh");
            SendMessage(EDIT_ALTDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "%d", seuil_moy);
            SendMessage(EDIT_ALTVAL, WM_SETTEXT, NULL, (LPARAM)temp_buf);
        }
        if ((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0)==3))
        {
            //Reference
            sprintf(temp_buf, "STD_reference");
            SendMessage(EDIT_STDDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "ALT_reference");
            SendMessage(EDIT_ALTDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "0.0037");
            SendMessage(EDIT_ALTVAL, WM_SETTEXT, NULL, (LPARAM)temp_buf);
        }
        if ((SendMessage(COMBO_PARAM, CB_GETCURSEL, 0, 0)==4))
        {
            //2nd. Alpha risk
            sprintf(temp_buf, "STD_2ndclass_alpha_risk");
            SendMessage(EDIT_STDDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "ALT_2ndclass_alpha_risk");
            SendMessage(EDIT_ALTDIR, WM_SETTEXT, NULL, (LPARAM)temp_buf);
            sprintf(temp_buf, "0.1");
            SendMessage(EDIT_ALTVAL, WM_SETTEXT, NULL, (LPARAM)temp_buf);
        }
    }
    return;
}

static on_clic_check_alt (void)
{
    if ((SendMessage(CHECKBOX_ALT, BM_GETCHECK, 0,0))==BST_CHECKED)
    {
        //active
        SendMessage(COMBO_PARAM, CB_INSERTSTRING, -1, "Matrix rank");
        SendMessage(COMBO_PARAM, CB_INSERTSTRING, -1, "Anal. thresh.");
        SendMessage(COMBO_PARAM, CB_INSERTSTRING, -1, "Ref. thresh.");
        SendMessage(COMBO_PARAM, CB_INSERTSTRING, -1, "Reference");
        SendMessage(COMBO_PARAM, CB_INSERTSTRING, -1, "2nd. Alpha risk");
    }
    else if ((SendMessage(CHECKBOX_ALT, BM_GETCHECK, 0,0))==BST_UNCHECKED)
    {
        //inactive
                SendMessage(COMBO_PARAM, CB_RESETCONTENT, 0, 0);
    }
    return;
}

static void clicsum (void)
{
    char temp_char[10];
    int id_im_ref;
    int max_shift;
    int i, j, k, l, m, n;
    int *shift_x;
    int *shift_y;
    double *critere;
    int temp_diff;
    double crit_min;
    int k_min, l_min;
    unsigned int temp_pix;
    FILE *file_out;
    sprintf(buff, "clic : %d");
    SetWindowText(hwndStatic, buff);
    id_im_ref= SendMessage(COMBO_SUM, CB_GETCURSEL, 0,0);
    if (nbplan<2 || id_im_ref==CB_ERR )
    {
        
        sprintf(buff, "Incomplete selection.");
        SetWindowText(hwndStatic, buff);
    }
    else
    {
        if (is_sum_calculated==1)
        {
        sprintf(buff, "Sum already calculated.");
        SetWindowText(hwndStatic, buff);
        }
        else {
        // the sum is calculated
        SendMessage(EDIT_SHIFT,EM_GETLINE,  0, &temp_char);
        max_shift = atoi(temp_char); 
	shift_x = (int*) calloc(nbplan, sizeof(int));
	shift_y = (int*) calloc(nbplan, sizeof(int));
	critere = (double*) calloc((2*max_shift+1)*(2*max_shift+1), sizeof(double));
	shift_x[0]=0;
	shift_y[0]=0;
	// determination of shifts for each plan
            for (m=1; m<nbplan; m++)
            {
		sprintf(buff, "Computation of plane %d / %d ... Please wait", m+1, nbplan);
		SetWindowText(hwndStatic, buff);
                for (k=-max_shift; k<(max_shift+1); k++)
                {
                for (l=-max_shift; l<(max_shift+1); l++)
                {
                    critere[(k+max_shift)*(2*max_shift+1)+l+max_shift]=0.0;
                    for (i=max_shift; i<(raster_line-max_shift); i++)
                    {
                    for (j=max_shift; j<(raster_col-max_shift); j++)
                    {
                        if (((i-shift_x[m-1]-k)<0) || ((j-shift_y[m-1]-l)<0) || ((i-shift_x[m-1]-k)>(raster_line-1)) || ((j-shift_y[m-1]-l)>(raster_col-1)))
                        {
                        temp_diff=image[m*raster_line*raster_col*nbmass+id_im_ref*raster_line*raster_col+(i)*raster_col+j];
                        }
                        else
                        {
                        temp_diff=image[m*raster_line*raster_col*nbmass+id_im_ref*raster_line*raster_col+(i)*raster_line+j]-image[(m-1)*raster_line*raster_col*nbmass+id_im_ref*raster_line*raster_col+(i-shift_x[m-1]-k)*raster_col+j-shift_y[m-1]-l];
                        }
                        critere[(k+max_shift)*(2*max_shift+1)+(l+max_shift)]+=sqrt(temp_diff*temp_diff);
                    }
                    }
                }
                }            // For each plan, the weakest criterion is chosen
            crit_min=critere[0];
            k_min=-max_shift;
            l_min=-max_shift;
            for (k=-max_shift; k<(max_shift+1); k++)
            {
                for (l=-max_shift; l<(max_shift+1); l++)
                {
                    if (critere[(k+max_shift)*(2*max_shift+1)+l+max_shift]<crit_min)
                    {
                    crit_min=critere[(k+max_shift)*(2*max_shift+1)+l+max_shift];
                    k_min=k;
                    l_min=l;
                    }
                }
            }
	    shift_x[m]=k_min;
	    shift_y[m]=l_min;
        }
// calculation of sums
   // for idmass
   for (n=0; n<nbmass; n++)
   {
        for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
                temp_pix=0;
                
                for (m=0; m<nbplan; m++)
                    {
                    if (((i-shift_x[m])<0) || ((i-shift_x[m])>(raster_line-1)) || ((j-shift_y[m])<0) || ((j-shift_y[m])>(raster_col-1)))
                    {
                    // nothing !
                    }
                    else {
                    temp_pix+=image[m*raster_line*raster_col*nbmass+n*raster_line*raster_col+(i-shift_x[m])*raster_line+j-shift_y[m]];
                    }
                    }
                image[nbplan*raster_line*raster_col*nbmass+n*raster_line*raster_col+(i)*raster_col+j]=temp_pix;
            }
        }
   }
   file_out=fopen("shift.txt", "w");
   fprintf(file_out, "max_shift:%d\n", max_shift);
for (m=0; m<nbplan; m++)
{
    fprintf(file_out, "%d\t%d\n", shift_x[m], shift_y[m]);
}
	fclose(file_out);
        free(shift_x);
	free(shift_y);
	free(critere);
        //end
        sprintf(buff, "Sum completed. Ready ...");
        SetWindowText(hwndStatic, buff);
        }
    }
    return;
}
static void clicsum_alt (void)
{
    //23 march 2015 projection method
    char temp_char[10];
    int id_im_ref;
    int max_shift;
    int i, j, k, l, m, n;
    float *vect_x_ref, *vect_y_ref, *vect_x_active, *vect_y_active;
    int max_im_ref, max_im_active;
    int *shift_x;
    int *shift_y;
    double *critere;
    double temp_diff;
    double crit_min;
    int k_min, l_min;
    unsigned int temp_pix;
    FILE *file_out;
    id_im_ref= SendMessage(COMBO_SUM, CB_GETCURSEL, 0,0);
    if (nbplan<2 || id_im_ref==CB_ERR )
    {
        
        sprintf(buff, "Incomplete selection.");
        SetWindowText(hwndStatic, buff);
    }
    else
    {
        if (is_sum_calculated==1)
        {
        sprintf(buff, "Sum already calculated.");
        SetWindowText(hwndStatic, buff);
        }
        else {
        // the sum is calculated
        SendMessage(EDIT_SHIFT,EM_GETLINE,  0, &temp_char);
        max_shift = atoi(temp_char);
        sprintf(buff, "max shift:%d", max_shift);
        SetWindowText(hwndStatic, buff);
        shift_x = (int*) calloc(nbplan, sizeof(int));
	shift_y = (int*) calloc(nbplan, sizeof(int));
	critere = (double*) calloc((2*max_shift+1), sizeof(double));
	vect_x_ref = (float*) calloc(raster_col, sizeof(float));
vect_x_active = (float*) calloc(raster_col, sizeof(float));
vect_y_ref = (float*) calloc(raster_line, sizeof(float));
vect_y_active = (float*) calloc(raster_line, sizeof(float));

shift_x[0]=0;
	shift_y[0]=0;

	// calculate the y reference projection
max_im_ref=0;

for (k=0; k<raster_line; k++)
{
    for (l=0; l<raster_col; l++)
    {
        vect_y_ref[k]+=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+(k)*raster_col+l];
        vect_x_ref[l]+=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+(k)*raster_col+l];
    }
}

max_im_ref=vect_y_ref[0];
for (k=1; k<raster_line; k++)
    {
    max_im_ref+=vect_y_ref[k];
    }
max_im_ref=max_im_ref/raster_line;
for (k=0; k<raster_line; k++)
    {
    vect_y_ref[k]=vect_y_ref[k]/max_im_ref;
    }

max_im_ref=vect_x_ref[0];
// calculate the x reference projection
for (l=1; l<raster_col; l++)
    {
    max_im_ref+=vect_x_ref[l];
    }
max_im_ref=max_im_ref/raster_col;

for (l=0; l<raster_col; l++)
    {
    vect_x_ref[l]=vect_x_ref[l]/max_im_ref;
    }



	// determination of shifts for each plan
            for (m=1; m<nbplan; m++)
            {
		sprintf(buff, "Computation of plane %d / %d ... Please wait", m+1, nbplan);
		SetWindowText(hwndStatic, buff);
max_im_active=0;
for (k=0; k<raster_line; k++)
{
vect_y_active[k]=0;
}

for (l=0; l<raster_col; l++)
{

    vect_x_active[l]=0;
}
// calculation of the active projection y

for (k=0; k<raster_line; k++)
{
    for (l=0; l<raster_col; l++)
    {
        vect_y_active[k]+=image[m*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+(k)*raster_col+l];
        vect_x_active[l]+=image[m*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+(k)*raster_col+l];

    }
}
max_im_active=vect_y_active[0];

for (k=1; k<raster_line; k++)
{
    max_im_active+=vect_y_active[k];

}
max_im_active=max_im_active/raster_line;
for (k=0; k<raster_line; k++)
{
vect_y_active[k]=vect_y_active[k]/max_im_active;
}// calculation of the active projection x
max_im_active=vect_x_active[0];
for (l=1; l<raster_col; l++)
{
max_im_active+=vect_x_active[l];
}
max_im_active=max_im_active/raster_col;
for (l=0; l<raster_col; l++)
{

    vect_x_active[l]=vect_x_active[l]/max_im_active;
}
//registration y
                for (k=-max_shift; k<(max_shift+1); k++)
                {
                    critere[k+max_shift]=0.0;

                    for (i=max_shift; i<(raster_line-max_shift); i++)
                    {


                        temp_diff=vect_y_active[i-k]-vect_y_ref[i];


                        critere[(k+max_shift)]+=sqrt(temp_diff*temp_diff);
                    }
                    }

                           // for each plan, the weakest criterion is chosen
            crit_min=critere[0];
            k_min=-max_shift;

            for (k=-max_shift; k<(max_shift+1); k++)
            {

                                    if (critere[(k+max_shift)]<crit_min)
                    {
                    crit_min=critere[(k+max_shift)];
                    k_min=k;
                    }
                }

                 shift_x[m]=k_min;


//registration x
                for (l=-max_shift; l<(max_shift+1); l++)
                {
                    critere[l+max_shift]=0.0;

                    for (j=max_shift; j<(raster_col-max_shift); j++)
                    {


                        temp_diff=vect_x_active[j-l]-vect_x_ref[j];


                        critere[(l+max_shift)]+=sqrt(temp_diff*temp_diff);
                    }
                    }

                           // for each plan, the weakest criterion is chosen
            crit_min=critere[0];
            l_min=-max_shift;

            for (l=-max_shift; l<(max_shift+1); l++)
            {

                                 if (critere[(l+max_shift)]<crit_min)
                    {
                    crit_min=critere[(l+max_shift)];
                    l_min=l;
                    }
                }
                 shift_y[m]=l_min;

        }

// calculation of sums
   // for idmass
   for (n=0; n<nbmass; n++)
   {
               
        for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
                temp_pix=0;
                
                for (m=0; m<nbplan; m++)
                    {
                    if (((i-shift_x[m])<0) || ((i-shift_x[m])>(raster_line-1)) || ((j-shift_y[m])<0) || ((j-shift_y[m])>(raster_col-1)))
                    {
                    // nothing !
                    }
                    else {
                    temp_pix+=image[m*raster_col*raster_line*nbmass+n*raster_col*raster_line+(i-shift_x[m])*raster_col+j-shift_y[m]];
                    }
                    }
                image[nbplan*raster_col*raster_line*nbmass+n*raster_col*raster_line+(i)*raster_col+j]=temp_pix;
            }
        }

   }
file_out=fopen("shift.txt", "w");
for (m=0; m<nbplan; m++)
{
    fprintf(file_out, "%d\t%d\n", shift_x[m], shift_y[m]);
}
	fclose(file_out);
        free(shift_x);
	free(shift_y);
	free(critere);
    free(vect_x_ref);
	free(vect_x_active) ;
	free(vect_y_ref) ;
	free(vect_y_active);
        //end

        sprintf(buff, "Sum completed. Ready ...");
        SetWindowText(hwndStatic, buff);
        }
    }
    return;
}
double **createTable(int nbLin, int nbCol)
//table declaration for the joint histogram (6 may 2015)
{

	double **tableau = (double **)malloc(sizeof(double*)*nbLin);
	double *tableau2 = (double *)malloc(sizeof(double)*nbCol*nbLin);
	int i;
	for( i = 0 ; i < nbLin ; i++){
		tableau[i] = &tableau2[i*nbCol];
	}
	return tableau;
}

void freeTable(double **tableau){
	free(tableau[0]);
	free(tableau);
}

static void clicsum_histogramme (void)
{
    //registration by joint histogram method  (6 may 2015)
    //Loc Thibaud and Anthony Delaune
    char temp_char[10];
    int id_im_ref;
    int max_shift;
    int i, j, k, l, m, n, num_plan, delta_i, delta_j, nb_pix, delta_i_opt, delta_j_opt;
    int *im_norm_ref, *im_norm_act;
    unsigned int max_im_ref, max_im_active, min_im_ref, min_im_active;
    int *shift_i;
    int *shift_j;
    double **H;

    double  tempo;

    unsigned int temp_pix;
    float hist_2D[256][256]={{0}};

    FILE *file_out;
    id_im_ref= SendMessage(COMBO_SUM, CB_GETCURSEL, 0,0);

    if (nbplan<2 || id_im_ref==CB_ERR )
    {
        
        printf("Incomplete selection or only one plane. Nothing will be calculated\n");
    }
    else
    {
        if (is_sum_calculated==1)
        {
        printf("The sum is already calculated. Nothing will be calculated\n");
        }
        else {
        // the sum is calculated
        SendMessage(EDIT_SHIFT,EM_GETLINE,  0, &temp_char);
        max_shift = atoi(temp_char);

shift_i = (int*) calloc(nbplan, sizeof(int));
shift_j = (int*) calloc(nbplan, sizeof(int));
H=createTable((2*max_shift+1), (2*max_shift+1));
im_norm_ref = (int*) calloc(raster_col*raster_line, sizeof(int));

shift_i[0]=0;
shift_j[0]=0;
min_im_ref=image[id_im_ref*raster_col*raster_line+0+0*raster_col];
max_im_ref=image[id_im_ref*raster_col*raster_line+0+0*raster_col];

///search in the 1 image file for minimum and maximum values
for (j=0; j<raster_line; j++)
    {
        for (i=0; i<raster_col; i++)
        {
            if ((image[id_im_ref*raster_col*raster_line+i+j*raster_col])<min_im_ref)
            {
                min_im_ref=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
            }

            else if ((image[id_im_ref*raster_col*raster_line+i+j*raster_col])>max_im_ref)//search of maxima
            {
                max_im_ref=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
            }

        }
    }





///normalize image number 1 to grayscale (256 levels)

    for (i=0; i<(raster_line); i++)
    {
        for (j=0; j<raster_col; j++)
        {
            im_norm_ref[i*raster_col+j]=(int)255*((float)image[id_im_ref*raster_col*raster_line+i+j*raster_col]-(float)min_im_ref)/((float)max_im_ref-(float)min_im_ref);
        }
    }



///---------------------------------------------------------------------------------------main loop

    for (num_plan = 1 ; num_plan < (nbplan) ; num_plan++)
    {
    ///search in the 2 image file for minumum and maximum values
		sprintf(buff, "Computation of plane %d / %d ... Please wait", (num_plan+1), nbplan);
		SetWindowText(hwndStatic, buff);

        im_norm_act = (int*)calloc(raster_col*raster_line, sizeof(int)) ; 
min_im_active=image[(num_plan)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+0+0*raster_col];
max_im_active=image[(num_plan)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+0+0*raster_col];

        for (j=0; j<raster_line; j++)
        {
            for (i=0; i<raster_col; i++)
            {
                if ((image[(num_plan)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col])<min_im_active)
                {
                    min_im_active=image[(num_plan)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
                }

                if ((image[(num_plan)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col])>max_im_active)
                {
                    max_im_active=image[(num_plan)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
                }

            }
        }

    ///normalize image number 1 to grayscale (256 levels)

        //normalize image number 2 to grayscale

        for (i=0; i<(raster_line); i++)
        {
            for (j=0; j<raster_col; j++)
            {
                im_norm_act[i*raster_col+j]=(int)((float)image[(num_plan)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i*raster_col+j]-(float)min_im_active)/((float)max_im_active-(float)min_im_active)*255; 
            }
        }

    ///calculation of the joint histogram of the 2 images
        for (delta_j= (-max_shift); delta_j<(max_shift+1); delta_j++)
        {
            for (delta_i= (-max_shift); delta_i<(max_shift+1); delta_i++)
            {
                nb_pix = 0;

                for (j=0 ; j<raster_line; j++)
                {
                    for (i=0 ; i<raster_col; i++)
                    {

                        if (((i-delta_i)>-1) && ((j-delta_j)>-1) && ((i-delta_i)<raster_col) && ((j-delta_j)<raster_line))
                        {
                            m = im_norm_ref[i+j*raster_col];
                            n = im_norm_act[(i-delta_i)+(j-delta_j)*raster_col];

                            hist_2D[m][n]=1+hist_2D[m][n];
                            nb_pix++;


                        }

                    }// i loop out

                }

            //calculation of H[delta_i,delta_j]
                for (m=0; m<256; m++)
                {
                    for (n=0; n<256; n++)
                    {

                        if ((hist_2D[m][n]>0) && (nb_pix!=0))
                        {

		H[delta_i+max_shift][delta_j+max_shift] += ((-hist_2D[m][n])/nb_pix)*log10(((hist_2D[m][n])/nb_pix));

                        }
                        hist_2D[m][n]=0;


                    }
                }

            }// delta_i loop out
        }//delta_j loop out



        tempo=H[0][0];

        for (delta_j=(-max_shift); delta_j<(max_shift+1); delta_j++)
        {

           for (delta_i=(-max_shift); delta_i<(max_shift+1); delta_i++)
           {
                if ((H[delta_i+max_shift][delta_j+max_shift])<tempo)
                {
                    tempo=H[delta_i+max_shift][delta_j+max_shift];
                    delta_i_opt=delta_i;
                    delta_j_opt=delta_j;


                }
                H[delta_i+max_shift][delta_j+max_shift] = 0;

           }
       }


    shift_i[num_plan]=delta_i_opt; 
    shift_j[num_plan]=delta_j_opt;
    free(im_norm_act);

    }///end of the main loop

    free(im_norm_ref);
    freeTable(H);

//sum of plans
   for (n=0; n<nbmass; n++)
   {
               
        for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
                temp_pix=0;
                
                for (m=0; m<nbplan; m++)
                    {
                    if (((i-shift_i[m])<0) || ((i-shift_i[m])>(raster_line-1)) || ((j-shift_j[m])<0) || ((j-shift_j[m])>(raster_col-1)))
                    {
                    // nothing !
                    }
                    else {
                    temp_pix+=image[m*raster_col*raster_line*nbmass+n*raster_col*raster_line+(i-shift_i[m])*raster_col+j-shift_j[m]];
                    }
                    }
                image[nbplan*raster_col*raster_line*nbmass+n*raster_col*raster_line+(i)*raster_col+j]=temp_pix;
            }
        }

   }
file_out=fopen("shift.txt", "w");
for (m=0; m<nbplan; m++)
{
    fprintf(file_out, "%d\t%d\n", shift_i[m], shift_j[m]);
}
	fclose(file_out);


    free(shift_i);
    free(shift_j);
}
}
        sprintf(buff, "Sum completed. Ready ...");
        SetWindowText(hwndStatic, buff);
    return;
}

static void clicsum_SMC (void)
{
    //registration by least square method (6 may 2015)
    //Loc Thibaud and Anthony Delaune
    char temp_char[10];
    int id_im_ref;
    int max_shift;
    int i, j, k, l, m, n, num_plan, delta_i, delta_j, nb_pix, delta_i_opt, delta_j_opt;
    int *im_norm_ref, *im_norm_act;
    int max_im_ref, max_im_active, min_im_ref, min_im_active;
    int *shift_i;
    int *shift_j;
    double **H;
    double temp_diff;
    double crit_min, tempo;
    int k_min, l_min;
    unsigned int temp_pix;


    FILE *file_out;
    id_im_ref= SendMessage(COMBO_SUM, CB_GETCURSEL, 0,0);

    if (nbplan<2 || id_im_ref==CB_ERR )
    {
        
        printf("Incomplete selection or only one plane. Nothing will be calculated\n");
    }
    else
    {
        if (is_sum_calculated==1)
        {
        printf("The sum is already calculated. Nothing will be calculated\n");
        }
        else {
        // the sum is calculated
        SendMessage(EDIT_SHIFT,EM_GETLINE,  0, &temp_char);
        max_shift = atoi(temp_char);
        sprintf(buff, "max shift:%d", max_shift);
        SetWindowText(hwndStatic, buff);

shift_i = (int*) calloc(nbplan, sizeof(int));
shift_j = (int*) calloc(nbplan, sizeof(int));
H=createTable((2*max_shift+1), (2*max_shift+1));
im_norm_ref = (int*) calloc(raster_col*raster_line, sizeof(int));
im_norm_act = (int*) calloc(raster_col*raster_line, sizeof(int));

shift_i[0]=0;
shift_j[0]=0;
min_im_ref=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+0+0*raster_col];
max_im_ref=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+0+0*raster_col];
///search in the 1 image file for the minimum and maximum values
    for (j=0; j<raster_line; j++)
    {
        for (i=0; i<raster_col; i++)
        {
            if (image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col]<min_im_ref)
            {
                min_im_ref=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
            }

            if (image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col]>max_im_ref)//search of maxima
            {
                max_im_ref=image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
            }

        }
    }



///normalize image number 1 to grayscale (256 levels)

    for (i=0; i<(raster_line); i++)
    {
        for (j=0; j<raster_col; j++)
        {
            im_norm_ref[i*raster_col+j]=(int)((float)image[0*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col]-(float)min_im_ref)/((float)max_im_ref-(float)min_im_ref)*255;
        }
    }



///---------------------------------------------------------------------------------------main loop

    for (num_plan = 2 ; num_plan < (nbplan+1) ; num_plan++)
    {
    ///search in the 2 image file for minimum and maximum values 
		sprintf(buff, "Computation of plane %d / %d ... Please wait", num_plan, nbplan);
		SetWindowText(hwndStatic, buff);

        im_norm_act = (int*)calloc(raster_col*raster_line, sizeof(int)) ; 
min_im_active=image[(num_plan-1)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+0+0*raster_col];
max_im_active=image[(num_plan-1)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+0+0*raster_col];

        for (j=0; j<raster_line; j++)
        {
            for (i=0; i<raster_col; i++)
            {
                if (image[(num_plan-1)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col]<min_im_active)
                {
                    min_im_active=image[(num_plan-1)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
                }

                if (image[(num_plan-1)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col]>max_im_active)
                {
                    max_im_active=image[(num_plan-1)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i+j*raster_col];
                }

            }
        }

    ///normalize image number 1 to grayscale (256 levels)

        //normalize image number 2 to grayscale

        for (i=0; i<(raster_line); i++)
        {
            for (j=0; j<raster_col; j++)
            {
                im_norm_act[i*raster_col+j]=(int)((float)image[(num_plan-1)*raster_line*raster_col*nbmass+id_im_ref*raster_col*raster_line+i*raster_col+j]-(float)min_im_active)/((float)max_im_active-(float)min_im_active)*255; 
            }
        }

    ///calculation of the true-likelihood function for each offset
        for (delta_j= (-max_shift); delta_j<(max_shift+1); delta_j++)
        {
            for (delta_i= (-max_shift); delta_i<(max_shift+1); delta_i++)
            {
                nb_pix = 0;

                for (j=0 ; j<raster_line; j++)
                {
                    for (i=0 ; i<raster_col; i++)
                    {

                        if (((i-delta_i)>-1) && ((j-delta_j)>-1) && ((i-delta_i)<raster_col) && ((j-delta_j)<raster_line))
                        {
                            m = im_norm_ref[i+j*raster_col];
                            n = im_norm_act[(i-delta_i)+(j-delta_j)*raster_col];
                            H[delta_i+max_shift][delta_j+max_shift] += (m-n)*(m-n);
                            nb_pix++;


                        }

                    }//i loop out

                }
                H[delta_i+max_shift][delta_j+max_shift] = (H[delta_i+max_shift][delta_j+max_shift])/(nb_pix*nb_pix);
            }//delta_i loop out
        }//delta_j loop out



        tempo=H[0][0];

        for (delta_j=(-max_shift); delta_j<(max_shift+1); delta_j++)
        {

           for (delta_i=(-max_shift); delta_i<(max_shift+1); delta_i++)
           {
                if ((H[delta_i+max_shift][delta_j+max_shift])<tempo)
                {
                    tempo=H[delta_i+max_shift][delta_j+max_shift];
                    delta_i_opt=delta_i;
                    delta_j_opt=delta_j;


                }
                H[delta_i+max_shift][delta_j+max_shift] = 0;

           }
       }


    shift_i[num_plan-1]=delta_i_opt; 
    shift_j[num_plan-1]=delta_j_opt;
    free(im_norm_act);



    }///end of the main loop

    free(im_norm_ref);
    freeTable(H);

//sum of plans
   for (n=0; n<nbmass; n++)
   {
   
        for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
                temp_pix=0;
                
                for (m=0; m<nbplan; m++)
                    {
                    if (((i-shift_i[m])<0) || ((i-shift_i[m])>(raster_line-1)) || ((j-shift_j[m])<0) || ((j-shift_j[m])>(raster_col-1)))
                    {
                    // nothing !
                    }
                    else {
                    temp_pix+=image[m*raster_col*raster_line*nbmass+n*raster_col*raster_line+(i-shift_i[m])*raster_col+j-shift_j[m]];
                    }
                    }
                image[nbplan*raster_col*raster_line*nbmass+n*raster_col*raster_line+(i)*raster_col+j]=temp_pix;
            }
        }

   }
file_out=fopen("shift.txt", "w");
for (m=0; m<nbplan; m++)
{
    fprintf(file_out, "%d\t%d\n", shift_i[m], shift_j[m]);
}
	fclose(file_out);


    free(shift_i);
    free(shift_j);
}
}
        sprintf(buff, "Sum completed. Ready ...");
        SetWindowText(hwndStatic, buff);
    return;
}

void change_denom(void)
{
    int i, j, index;
    int num_image;
    num_image=SendMessage(COMBO_DENOM, CB_GETCURSEL, 0,0);
    maxpix=0;
    unsigned int tempo;
    int tmp_pix;
if (num_image!=CB_ERR)
{

for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
                if ((image[plan_actif*raster_line*raster_col*nbmass+num_image*raster_line*raster_col+i*raster_col+j])>maxpix)
                    maxpix=image[plan_actif*raster_line*raster_col*nbmass+num_image*raster_line*raster_col+i*raster_col+j];
            }
        }
if (maxpix==0)
                {
                maxpix=1;
                }
SendMessage(TRACKBAR_REF, TBM_SETRANGEMAX, TRUE, maxpix);
SendMessage(TRACKBAR_TRESH, TBM_SETRANGEMAX, TRUE, maxpix);
for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
            index=3*(i*raster_col+j);
            tmp_pix=image[plan_actif*raster_line*raster_col*nbmass+num_image*raster_line*raster_col+i*raster_col+j];
            im_denom[index]=(int)(255*tmp_pix/maxpix);
            im_denom[index+1]=im_denom[index];
            im_denom[index+2]=im_denom[index];
            }
        }
draw_im_denom();
}
    return;
}

void draw_im_denom(void)
{
    int index, i, j;
    hdc = GetDC(image_box);
for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
            index=3*(i*raster_col+j);
            SetPixelV(hdc, j, i, RGB(im_denom[index], im_denom[index+1], im_denom[index+2]));
            }
        }
ReleaseDC(image_box, hdc);
return;
}

void change_seuil_tresh (void)
{
    char tempo_buf[6];
    int tmp_pix, i, j, index;
    int num_image;
    num_image=SendMessage(COMBO_DENOM, CB_GETCURSEL, 0,0);
    seuil_denom=SendMessage(TRACKBAR_TRESH, TBM_GETPOS, 0, 0);
    sprintf(tempo_buf, "%d", seuil_denom);
    SetWindowText(STATIC_TRESH, tempo_buf);
if (num_image!=CB_ERR)
{
for (i=0; i<raster_line; i++)
        {
        for (j=0; j<raster_col; j++)
        {
            index=3*(i*raster_col+j);
            tmp_pix=image[plan_actif*raster_line*raster_col*nbmass+num_image*raster_line*raster_col+i*raster_col+j];
            if (tmp_pix<seuil_denom)
                {
                im_denom[index]=255;
                }
            else{
                im_denom[index]=(int)(255*tmp_pix/maxpix);
                }
        }
    }
draw_im_denom();
}
    return;
}

void change_seuil_ref (void)
{
char tempo_buf[6];
int i, j, index, tmp_pix;
int num_image;
    num_image=SendMessage(COMBO_DENOM, CB_GETCURSEL, 0,0);
    seuil_moy=SendMessage(TRACKBAR_REF, TBM_GETPOS, 0, 0);
    sprintf(tempo_buf, "%d", seuil_moy);
    SetWindowText(STATIC_REF, tempo_buf);
if (num_image!=CB_ERR)
{
    for (i=0; i<raster_line; i++)
        {
            for (j=0; j<raster_col; j++)
            {
            index=3*(i*raster_col+j);
            tmp_pix=image[plan_actif*raster_line*raster_col*nbmass+num_image*raster_line*raster_col+i*raster_col+j];
            if (tmp_pix<seuil_moy)
            {
              im_denom[index+1]=255;
            }
            else{
		im_denom[index+1]=(int)(255*tmp_pix/maxpix);
		}
	    }
        }
draw_im_denom();
}
    return;
}

void clicplane(void)
{
    int i, j;
    plan_actif = SendMessage(COMBO_PLANE, CB_GETCURSEL, 0,0);
    SendMessage(COMBO_NUM, CB_RESETCONTENT, 0, 0);
    SendMessage(COMBO_DENOM, CB_RESETCONTENT, 0, 0);
    SendMessage(COMBO_NORM, CB_RESETCONTENT, 0, 0);
    for (j=0; j<nbmass; j++)
    {
        //completing image combobox
    SendMessage(COMBO_NUM, CB_ADDSTRING, 0, nom_mass[j]);
    SendMessage(COMBO_DENOM, CB_ADDSTRING, 0, nom_mass[j]);
    SendMessage(COMBO_NORM, CB_ADDSTRING, 0, nom_mass[j]);
    }
    return;
}


int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hPrevInstance,
                                                LPSTR lpCmdLine, int nCmdShow)
{
    im_denom=(int*)calloc(1, sizeof(int));
    MSG msg;
    WNDCLASS wc;
    HMENU hMenu, hSousMenu;
    hinst = hinstance;
    wc.style = 0 ;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hinstance;
    wc.hIcon = NULL;
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetSysColorBrush(COLOR_3DFACE);
    wc.lpszMenuName =  NULL;
    wc.lpszClassName = "MaWinClass";

    if(!RegisterClass(&wc)) return FALSE;

    hSousMenu = CreateMenu();
    AppendMenu(hSousMenu, MF_STRING, IDM_OPEN, "Open...");
    AppendMenu(hSousMenu, MF_STRING, IDM_SAVE, "Save...");
    AppendMenu(hSousMenu, MF_SEPARATOR, 0, NULL);
    AppendMenu(hSousMenu, MF_STRING, IDM_QUIT, "Exit");
    hMenu  = CreateMenu();
    AppendMenu(hMenu,MF_POPUP,(UINT)hSousMenu,"File");
    AppendMenu(hMenu,MF_STRING,IDM_ABOUT,"About");

    hwnd = CreateWindow("MaWinClass", "SIEDmaker4Win", WS_OVERLAPPEDWINDOW,
                                   CW_USEDEFAULT, CW_USEDEFAULT, 800, 580,
                                                   NULL, hMenu, hinstance, NULL);
    if (!hwnd)  return FALSE;
    ShowWindow(hwnd, nCmdShow);
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return msg.wParam;
}
/******************************************************************************/

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static HWND hEdit;
    static HWND hwndStatic;
    int h;

    switch (uMsg)
    {
        case WM_CREATE:
            {
             fill_the_window(hwnd);
        return 0;
            }

        case WM_CLOSE:
            {
              free(image);
              free(image_sum);
              free(im_denom);
              DestroyWindow(hwnd);
            return 0;
            }

        case WM_COMMAND:

              if(LOWORD(wParam) == IDM_ABOUT)
              {
                  //about
                    MessageBox(hwnd, "SIEDmaker4win v0.95 2015 Anthony Delaune Universit de Rouen", "About", MB_ICONINFORMATION);
                    break;
              }
            if(LOWORD(wParam) == IDM_OPEN)
              {
                OPENFILENAME ofn;
                ZeroMemory(&ofn, sizeof(OPENFILENAME));
                ofn.lStructSize = sizeof(OPENFILENAME);
                ofn.hwndOwner = hwnd;
                ofn.lpstrFile = szFile;
                ofn.nMaxFile = MAX_PATH;
                ofn.lpstrFilter =
                           "Fichier image SIMS\0*.im\0";
                ofn.nFilterIndex = 1;
                ofn.Flags =
                       OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

                if (GetOpenFileName(&ofn)==TRUE)
                 {
                    sprintf(buff, "Opening.\n May take a while...");
                    SetWindowText(hwndStatic, buff);

                    if (opensims(szFile))
                    {
                           sprintf(pathfich,"%s",szFile);
                           sprintf(buff, "File : %s opened", pathfich);
                    SetWindowText(hwndStatic, buff);
                    }
                    else
                    {
                        sprintf(buff, "Cannot open file.");
                        SetWindowText(hwndStatic, buff);
                    }
                 }
              return 0;
              }

            if(LOWORD(wParam) == IDM_QUIT) {
                    PostMessage(hwnd, WM_CLOSE,0,0);

                return 0;
            }

            if(LOWORD(wParam) == IDM_SAVE)
            {
            save();
            return 0;
            }
            if(LOWORD(wParam) == ID_RADIO_ONETAIL)
              {
                  two_tailed=0;
              }
             if(LOWORD(wParam) == ID_RADIO_TWOTAIL)
              {
                  two_tailed=1;
              }
             if(LOWORD(wParam) == ID_PUSH_SUM)
              {
                        if (sum_meth==3)
                        {
                            clicsum_alt();
                        }
                        if (sum_meth==1)
                        {
                            clicsum_histogramme();
                        }
                        if (sum_meth==2)
                        {
                            clicsum_SMC();
                        }

                        return 0;
              }
                if(LOWORD(wParam) == ID_COMBO_PLANE)
              {
                        clicplane();
                        return 0;
              }
              if(LOWORD(wParam) == ID_COMBO_DENOM)
              {
                        change_denom();
                        return 0;
              }
                if(LOWORD(wParam) == ID_RADIO_SUM_HHC)
              {
                  sum_meth=1;
                  return;
              }
                if(LOWORD(wParam) == ID_RADIO_SUM_MC)
              {
                  sum_meth=2;
                  return;
              }
                if(LOWORD(wParam) == ID_RADIO_SUM_PROJ)
              {
                  sum_meth=3;
                  return;
              }

                if(LOWORD(wParam) == ID_RADIO_RANK0)
              {
                  filtretype=0;
                  return;
              }
               if(LOWORD(wParam) == ID_RADIO_RANK1)
              {
                  filtretype=1;
                  return;
              }
               if(LOWORD(wParam) == ID_RADIO_RANK2)
              {
                  filtretype=2;
                  return;
              }
               if(LOWORD(wParam) == ID_RADIO_RANK3)
              {
                  filtretype=3;
                  return;
              }
               if(LOWORD(wParam) == ID_RADIO_RANK4)
              {
                  filtretype=4;
                  return;
              }
                if(LOWORD(wParam) == ID_CHECKBOX_ALT)
              {
                  on_clic_check_alt();
                  return;
              }
                if(LOWORD(wParam) == ID_COMBO_PARAM)
              {
                  on_choice_param();
                  return;
              }

        case WM_HSCROLL:
            {
               change_seuil_ref();
               change_seuil_tresh();
               return;
            }

        case WM_SIZE:
             MoveWindow(hEdit, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
             return 0;

        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;

        default:
            return DefWindowProc(hwnd, uMsg, wParam, lParam);
    }
}
